#!/usr/bin/python3

import amulet

seconds = 20000

d = amulet.Deployment(series='trusty')

d.add('mysql')
d.add('rsyslog')
d.configure('rsyslog', {
    'protocol': 'relp'
})
d.add('rsyslog-forwarder-ha')
d.configure('rsyslog-forwarder-ha', {
    'protocol': 'relp'
})
d.relate('rsyslog-forwarder-ha:juju-info', 'mysql:juju-info')
d.relate('rsyslog-forwarder-ha:syslog', 'rsyslog:syslog')

try:
    d.setup(timeout=seconds)
except amulet.helpers.TimeoutError:
    amulet.raise_status(amulet.SKIP, msg="Environment wasn't stood up in time")
except:
    raise

mysql_unit = d.sentry.unit['mysql/0']
rsyslog_unit = d.sentry.unit['rsyslog/0']

mysql_unit.run("logger 'testing'")

grep_result, grep_code = rsyslog_unit.run("grep testing /var/log/syslog")

if 'testing' not in grep_result:
    amulet.raise_status(amulet.FAIL,
                        'rsyslog relation not working properly '
                        'between rsyslog and rsyslog-forwarder-ha.')
